"""
Formulaire changement formation
"""

from flask_wtf import FlaskForm
from flask_wtf.file import FileField, FileAllowed, FileRequired

from wtforms import StringField, SubmitField, TextAreaField
from wtforms.validators import Length, Optional


class CreateDocxTemplateForm(FlaskForm):
    "Form. creation template"

    name = StringField(
        "Nom du template",
        validators=[Optional(), Length(max=100)],
        description="si non spécifié, utilisera le nom du fichier docx",
    )
    description = TextAreaField(
        "Description (optionnelle)",
        validators=[Optional(), Length(max=500)],
    )
    docx_file = FileField(
        "Fichier docx",
        validators=[
            FileAllowed(["docx"], "DOCX files only!"),
        ],
    )
    submit = SubmitField("Charger le document template (docx)")
    cancel = SubmitField("Annuler")

    def __init__(self, *args, edit=False, **kwargs):
        super().__init__(*args, **kwargs)
        if not edit:
            self.docx_file.validators.append(FileRequired())
