/*
 * Gestion des formulaires de note
 */

// Formulaire saisie de notes pour une évaluation

const form_etudid = parseInt(document.getElementById("etudiant_id").getAttribute("value"));

function get_note_min(field_id) {
  const note_field = get_note_field(field_id);
  return parseFloat(note_field.getAttribute("note_min"));
}

function get_note_max(field_id) {
  const note_field = get_note_field(field_id);
  return parseFloat(note_field.getAttribute("note_max"));
}

function get_evaluation_id(field_id) {
  const note_field = get_note_field(field_id);
  return parseInt(note_field.getAttribute("evaluation_id"));
}

function get_etudid(field_id) {
  return parseInt(form_etudid);
}

document.addEventListener("DOMContentLoaded", function () {
  const noteInputs = document.querySelectorAll("#formnotes .note");
  noteInputs.forEach(function (input) {
    input.addEventListener("input", function() {
      if (this.value !== this.getAttribute("data-last-saved-value")) {
        this.setAttribute("data-modified", "true");
      }
    });
    input.addEventListener("blur", input.addEventListener("blur", function(event){
      write_on_blur(event.currentTarget)
    }));
  });
});

function is_enter_key(event) {
  if (event.keyCode == 13) return true;
  if (event.which == 13) return true;
  if (event.charCode == 13) return true;
  return false;
}

function find_next_field(current_element) {
  const form_input = Array.from(document.querySelectorAll("#formnotes input"))
      .filter(elem => ! elem.disabled)
      .filter(elem => $(elem).is(':visible'));
  const current_index = form_input.indexOf(current_element)
  return ((current_index == form_input.length -1) ? form_input[current_index] : form_input[current_index+1]);
}
function enter_focus_next (elem, event) {
  if (is_enter_key(event)) {
    let next_elem = find_next_field(elem);
    if (next_elem != elem) {
      next_elem.focus();
      return true;
    } else {
      elem.blur();
      return false;
    }
  }
}

function update_jurylink(evaluation_id, v) {
  const note_field = get_note_field(evaluation_id);
  const jurylink = document.getElementById('jurylink');
  jurylink.innerHTML = make_jurylink(evaluation_id);
  jurylink.style.display = "inline";
}