// Formulaire saisie de notes pour une évaluation

const note_min = parseFloat(document.querySelector("#eval_note_min").textContent);
const note_max = parseFloat(document.querySelector("#eval_note_max").textContent);
const form_evaluation_id = parseInt(document.getElementById("formnotes_evaluation_id").getAttribute("value"));

function get_note_min(field_id) {
  return note_min;
}

function get_note_max(field_id) {
  return note_max;
}

function get_etudid(field_id) {
  return parseInt(get_note_field(field_id).getAttribute("data-etudid"));
}

document.addEventListener("DOMContentLoaded", function () {
  const noteInputs = document.querySelectorAll("#formnotes .note");
  noteInputs.forEach(function (input) {
    console.log(get_field_id(input));
    input.addEventListener("input", function() {
      this.setAttribute("data-modified", "true");
    });
    input.addEventListener("blur", input.addEventListener("blur", function(event){write_on_blur(event.currentTarget)} ));
  });

  const formInputs = document.querySelectorAll("#formnotes input");
  formInputs.forEach(function (input) {
    input.addEventListener("paste", paste_text);
  });

  const masquerBtn = document.querySelector(".btn_masquer_DEM");
  masquerBtn.addEventListener("click", masquer_DEM);
});

function get_evaluation_id(field_id) {
  return form_evaluation_id
}

// Contribution S.L.: copier/coller des notes

function paste_text(event) {
  event.stopPropagation();
  event.preventDefault();
  var clipb = event.clipboardData;
  var data = clipb.getData("Text");
  var list = data.split(/\r\n|\r|\n|\t| /g);
  var currentInput = event.currentTarget;
  var masquerDEM = document
    .querySelector("body")
    .classList.contains("masquer_DEM");

  for (var i = 0; i < list.length; i++) {
    if (!currentInput.disabled) { // skip DEM
       currentInput.value = list[i];
    }
    // --- trigger blur
    currentInput.setAttribute("data-modified", "true");
    var evt = new Event("blur", { bubbles: true, cancelable: true});
    currentInput.dispatchEvent(evt);
    // --- next input
    var sibbling = currentInput.parentElement.parentElement.nextElementSibling;
    while (
      sibbling &&
      (sibbling.style.display == "none" ||
        (masquerDEM && sibbling.classList.contains("etud_dem")))
    ) {
      sibbling = sibbling.nextElementSibling;
    }
    if (sibbling) {
      currentInput = sibbling.querySelector("input");
      if (!currentInput) {
        return;
      }
    } else {
      return;
    }
  }
}

function masquer_DEM() {
  document.querySelector("body").classList.toggle("masquer_DEM");
}

function update_jurylink(etudid, v) {
  const juryLink = document.getElementById("jurylink_" + etudid);
  const note_field = get_note_field(etudid)
  if (v !== note_field.getAttribute("data-orig-value")) {
    juryLink.innerHTML = make_jurylink(etudid);
  } else {
    juryLink.innerHTML = "";
  }
}