"""FormSemestreDemandeInscription

Revision ID: e67b6ef7bf8e
Revises: e0824c4f1b0b
Create Date: 2025-03-25 15:32:39.384494

"""

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "e67b6ef7bf8e"
down_revision = "f7dd70c0e50b"
branch_labels = None
depends_on = None


def upgrade():
    op.create_table(
        "form_semestre_demande_inscription",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("formsemestre_id", sa.Integer(), nullable=False),
        sa.Column("date_demande", sa.DateTime(timezone=True), nullable=False),
        sa.Column("date_validation", sa.DateTime(timezone=True), nullable=True),
        sa.Column("statut", sa.Integer(), server_default="0", nullable=False),
        sa.Column("numero", sa.Text(), server_default="", nullable=False),
        sa.Column("civilite", sa.String(length=1), nullable=False, server_default="M"),
        sa.Column("code_nip", sa.Text(), server_default="", nullable=False),
        sa.Column("code_ine", sa.Text(), server_default="", nullable=False),
        sa.Column("nom", sa.Text(), server_default="", nullable=False),
        sa.Column("prenom", sa.Text(), server_default="", nullable=False),
        sa.Column("email", sa.Text(), server_default="", nullable=False),
        sa.Column("telephone", sa.Text(), server_default="", nullable=False),
        sa.Column("niveau", sa.Text(), server_default="", nullable=False),
        sa.Column("motivation", sa.Text(), server_default="", nullable=False),
        sa.Column("piece_jointe", sa.LargeBinary(), nullable=True),
        sa.CheckConstraint("civilite IN ('M', 'F', 'X')"),
        sa.ForeignKeyConstraint(
            ["formsemestre_id"], ["notes_formsemestre.id"], ondelete="CASCADE"
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    with op.batch_alter_table(
        "form_semestre_demande_inscription", schema=None
    ) as batch_op:
        batch_op.create_index(
            batch_op.f("ix_form_semestre_demande_inscription_formsemestre_id"),
            ["formsemestre_id"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_form_semestre_demande_inscription_numero"),
            ["numero"],
            unique=True,
        )


def downgrade():
    with op.batch_alter_table(
        "form_semestre_demande_inscription", schema=None
    ) as batch_op:
        batch_op.drop_index(batch_op.f("ix_form_semestre_demande_inscription_numero"))
        batch_op.drop_index(
            batch_op.f("ix_form_semestre_demande_inscription_formsemestre_id")
        )

    op.drop_table("form_semestre_demande_inscription")
